﻿
local L = SOMETWEAKS_LOCALE

local o = CreateFrame("Frame")
o.name = "SomeTweaks"
InterfaceOptions_AddCategory(o)

local Title = o:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
Title:SetPoint("TOPLEFT", o, "TOPLEFT", 15, -15)
Title:SetText("SomeTweaks "..L["options"])

local md = o:CreateFontString(nil, "OVERLAY", "GameFontNormal")
md:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -15)
md:SetText(L["options md"])

local d1 = o:CreateFontString(nil, "OVERLAY", "GameFontNormal")
d1:SetPoint("TOPLEFT", md, "BOTTOMLEFT", 0, -30)
d1:SetText(L["options d1"])

Option1Checkbutton = CreateFrame("Checkbutton", "Option1Checkbutton", o, "OptionsCheckButtonTemplate")
Option1Checkbutton:SetPoint("TOPLEFT", d1, "BOTTOMLEFT", 0, -10)
Option1Checkbutton:SetScript("OnClick", function () SomeTweaksDB.options[1] = Option1Checkbutton:GetChecked() end)
Option1CheckbuttonText:SetText(L["options o1"])

local Option2Checkbutton = CreateFrame("Checkbutton", "Option2Checkbutton", o, "OptionsCheckButtonTemplate")
Option2Checkbutton:SetPoint("TOPLEFT", Option1Checkbutton, "BOTTOMLEFT", 0, 0)
Option2Checkbutton:SetScript("OnClick", function () SomeTweaksDB.options[2] = Option2Checkbutton:GetChecked() end)
Option2CheckbuttonText:SetText(L["options o2"])
Option2Checkbutton:SetScript("OnEnter", function(self)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(Option2Checkbutton, "ANCHOR_TOPLEFT")
	GameTooltip:SetText(L["options o2 t"])
	GameTooltip:Show()
end)
Option2Checkbutton:SetScript("OnLeave", function()
	GameTooltip:Hide()
end)

local Button1 = CreateFrame("Button", nil, o, "UIPanelButtonTemplate")
Button1:SetPoint("BOTTOMRIGHT", -15, 15)
Button1:SetText(L["options reload"])
Button1:SetWidth(Button1:GetFontString():GetStringWidth() + 40)
Button1:SetScript("OnClick", function() ReloadUI() end)

function SomeTweaksOptions_Init()
	Option1Checkbutton:SetChecked(SomeTweaksDB.options[1])
	Option2Checkbutton:SetChecked(SomeTweaksDB.options[2])
end
