﻿--[[
	SomeTweaks
]]

local db
local currency = {ids = {241, 390, 61, 515, 398, 384, 697, 81, 615, 393, 392, 361, 402, 395, 738, 754, 416, 677, 752, 614, 400, 394, 397, 676, 391, 401, 385, 396, 399, }}

if select(4, GetBuildInfo()) == 50400 then
	currency = {ids = {241, 390, 61, 515, 398, 384, 697, 81, 615, 393, 392, 361, 402, 395, 738, 754, 416, 677, 752, 614, 400, 394, 397, 676, 391, 401, 385, 396, 399,
		789, 777, 776, }}
end

local function Currency_Init()
	for i = 1, #currency.ids do
		local name = GetCurrencyInfo(currency.ids[i])
		currency[name] = currency.ids[i]
	end
end

local function MoveTalentSpecTabs()
	PlayerSpecTab1Background:SetTexCoord(0, 1, 1, 1, 0, 0, 1, 0)
	PlayerSpecTab2Background:SetTexCoord(0, 1, 1, 1, 0, 0, 1, 0)
	
	hooksecurefunc("PlayerTalentFrame_Update", function()
		PlayerSpecTab1:SetPoint("TOPLEFT", PlayerTalentFrame, "TOPRIGHT", -108, -469)
		PlayerSpecTab2:SetPoint("TOPLEFT", PlayerSpecTab1, "TOPRIGHT", 22, 0)
		PlayerSpecTab1Background:SetPoint("TOPLEFT", -21, 3)
		PlayerSpecTab2Background:SetPoint("TOPLEFT", -21, 3)
	end)
end

local function Backpack_OnClick(self, button, down)
	if not IsModifiedClick() then
		ToggleAllBags()
		BackpackButton_UpdateChecked(self)
	else
		if IsModifiedClick("OPENALLBAGS") then
			BackpackButton_OnClick(self, button)
		end
	end
end

local function Bag_OnClick(self, button, down)
	if not IsModifiedClick() then
		if GetInventoryItemTexture("player", self:GetID()) then
			ToggleAllBags()
		end
		BagSlotButton_UpdateChecked(self)
	else
		if IsModifiedClick("OPENALLBAGS") then
			BagSlotButton_OnClick(self, button)
		end
	end
end

local function ModifyBagButtonOnClickHandler()
	MainMenuBarBackpackButton:SetScript("OnClick", Backpack_OnClick)
	CharacterBag0Slot:SetScript("OnClick", Bag_OnClick)
	CharacterBag1Slot:SetScript("OnClick", Bag_OnClick)
	CharacterBag2Slot:SetScript("OnClick", Bag_OnClick)
	CharacterBag3Slot:SetScript("OnClick", Bag_OnClick)
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_LOGOUT")
local function eventHandler(self, event, ...)
	if event == "ADDON_LOADED" then
		if ... == "Blizzard_TalentUI" then
			if db.options[1] then
				MoveTalentSpecTabs()
			end
		elseif ... == "SomeTweaks" then
			SomeTweaksDB = SomeTweaksDB or {options = {1, 1}, currency = {}}
			db = SomeTweaksDB
			
			SomeTweaksOptions_Init()
			
			if db.options[2] then
				ModifyBagButtonOnClickHandler()
			end
		end
		
	elseif event == "PLAYER_LOGIN" then
		Currency_Init()
		GameTooltipAddCurrency()
		
	elseif event == "PLAYER_LOGOUT" then
		db.options = SomeTweaksDB.options
		SomeTweaksDB = db
		
	end
end
f:SetScript("OnEvent", eventHandler)

local cf = CreateFrame("Frame", nil, GameTooltip)
cf:SetAllPoints(GameTooltip)

local function ClearCurrencyFrame()
	if cf.r then
		for r = 1, cf.r do
			for t = 1, 3 do
				_G["GameTooltipTokenFrame"..r.."Token"..t]:Hide()
			end
		end
	end
end

local function CurrencyFrame_Update()
	local name, count, icon
	local r, t = 1, 1
	ClearCurrencyFrame()
	cf.f = cf.f or {}
	cf.r = 0
	local l = GameTooltip:NumLines()
	local d, w = 10, nil
	w = floor((cf:GetWidth() - 2*d)/3 + .5)
	for k, v in pairs(db.currency) do
		if t == 1 then
			if not cf.f[r] then
				cf.f[r] = CreateFrame("Frame", "GameTooltipTokenFrame"..r, cf, "GameTooltipTokenFrameTemplate")
			end
			GameTooltip:AddLine(" ")
			cf.f[r]:SetPoint("LEFT", "GameTooltipTextLeft"..l + r, "LEFT", 0, -1)
		end
		name, count, icon = GetCurrencyInfo(k)
		_G["GameTooltipTokenFrame"..r.."Token"..t].count:SetText(count)
		_G["GameTooltipTokenFrame"..r.."Token"..t].icon:SetTexture(icon)
		_G["GameTooltipTokenFrame"..r.."Token"..t]:SetPoint("RIGHT", cf.f[r], "LEFT", w*t, 0)
		_G["GameTooltipTokenFrame"..r.."Token"..t]:Show()
		t = t + 1
		cf.r = r
		if t == 4 then
			t = 1
			r = r + 1
		end
	end
	cf:Show()
	GameTooltip:Show()
end

function GameTooltipAddCurrency()
	PlayerFrame:HookScript("OnEnter", function()
		CurrencyFrame_Update()
	end)
	
	if IsAddOnLoaded("XPerl_Player") then
		XPerl_PlayernameFrame:HookScript("OnEnter", function()
			CurrencyFrame_Update()
		end)
		XPerl_Player:HookScript("OnEnter", function()
			CurrencyFrame_Update()
		end)
	end
	
	GameTooltip:HookScript("OnShow", function()
		cf:Hide()
	end)
	
	hooksecurefunc("TokenButton_OnClick", function(self)
		if not self.isHeader then
			local name = GetCurrencyListInfo(self.index)
			local c = currency[name]
			TokenFramePopupGameTooltipCheckBox:SetChecked(db.currency[c])
		end
	end)
end

local function SortCurrency()
	local s = {}
	for n in pairs(db.currency) do table.insert(s, n) end
	sort(s)
	db.currency = {}
	for _, v in pairs(s) do db.currency[v] = 1 end
end

function SetCurrencyGameTooltip(id, set)
	local name = GetCurrencyListInfo(id)
	local c = currency[name]
	db.currency[c] = set
	SortCurrency()
	CurrencyFrame_Update()
end
